【LeetCode】42. 接雨水 暴力法,动态规划

42. 接雨水
给定 n 个非负整数表示每个宽度为 1 的柱子的高度图,计算按此排列的柱子,下雨之后能接多少雨水。
上面是由数组 [0,1,0,2,1,0,1,3,2,1,2,1] 表示的高度图,在这种情况下,可以接 6 个单位的雨水(蓝色部分表示雨水)。 感谢 Marcos 贡献此图。
示例:
输入: [0,1,0,2,1,0,1,3,2,1,2,1]
输出: 6

【LeetCode】42. 接雨水 暴力法,动态规划_第1张图片

暴力法 会超出时间

  • 对于数组中的每一个数求出这个数需要接水的量
  • 接水的量等于此数左右最大值中的最小值 减去当前数字
  • 对于首尾两个数直接忽略
class Solution {
public:
    int trap(vector<int>& height) {
       
        int ans=0;
       for (int i=1;i<height.size()-1;i++){//第一个和最后一个数不需要注水 忽略
           int lmax=0,rmax=0;//放在循环内来初始化;
           for(int j=0;j<=i;j++){
               lmax=max(height[j],lmax);//从0到i 不能忽视i因为 i可能是最大值
           } 
           for(int j=i;j<height.size();j++){
               rmax=max(height[j],rmax);
               } 
           ans+=min(lmax,rmax)-height[i];  
       }
       return ans;
    }
};
  • 时间复杂度O(n2)

动态规划

  • 暴力法中每次找到某个数左右两边的最大值都需要扫描一遍,可以提前存储这个值
  • 找到数组从左到右的左边最大值lmax
  • 找到数组从右到左的右边最大值rmax
  • 遍历数组 把min(lmax[i],rmax[i])-height[i]加到ans上
class Solution {
public:
    int trap(vector<int>& height) {

        if(height.size()==0) 
        return 0;

        int size=height.size();
        vector<int> lmax(size),rmax(size);
        int ans=0;
        lmax[0]=height[0];
        for(int i=1;i<height.size();i++){
            lmax[i]=max(lmax[i+1],height[i]);
        }
        rmax[height.size()-1]= height[height.size()-1];
        for(int i=height.size()-2;i>=0;i--){
            rmax[i]=max(rmax[i-1],height[i]);
        }
        for(int i=1;i<height.size()-1;i++){
            ans=ans+min(rmax[i],lmax[i])-height[i];

        }
        return ans;
    }

};

相似题目:11. 盛最多水的容器 双指针,暴力搜索

你可能感兴趣的:(LeetCodes刷题之路)